/*********************************************************************NVMH1****
File:
hufo_fur_setup.h

Copyright (C) 1999, 2000 NVIDIA Corporation
This file is provided without support, instruction, or implied warranty of any
kind.  NVIDIA makes no guarantee of its fitness for a particular purpose and is
not liable under any circumstances for any damages or loss whatsoever arising
from the use or inability to use this file or items derived from it.

Comments:


******************************************************************************/

struct nv_mesh
{
    std::string     name;           // Convenience for debugging

    int             numv;           // number of vertices
    float *         v;              // vertices
                                    // tangent basis per vertex
    float *         tangent;
    float *         binormal;
    float *         normal;

    float *         t;              // texture coords

    int             matidx;         // material index into the ase::model

    int             numf;           // number of faces
    int *           f;              // faces (indices into the array of vertices)
};

typedef std::vector<nv_mesh*>   nv_mesh_array;
typedef nv_mesh_array::const_iterator nv_mesh_cit;
typedef nv_mesh_array::iterator nv_mesh_it;
