// ParticleDialog.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "ParticleDialog.h"
#include "common.h"
#include "resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

CParticleDialogApp theApp;

// Exported functions
extern "C"
{

BOOL ParticleDialog_ShowDialog(bool bShow)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	return theApp.ShowDialog(bShow);

}

BOOL ParticleDialog_Initialise(HWND hWndParent)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	return theApp.Initialise(hWndParent);

}

BOOL ParticleDialog_Free()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	return theApp.Free();

}

BOOL ParticleDialog_GetSettings(DialogSettings* pSettings)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	return theApp.GetSettings(pSettings);
}

BOOL ParticleDialog_SetSettings(DialogSettings* pSettings)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	return theApp.SetSettings(pSettings);
}

BOOL ParticleDialog_SetMaxParticles(int MaxParticles)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	return theApp.SetMaxParticles(MaxParticles);
}

}

/////////////////////////////////////////////////////////////////////////////
// CParticleDialogApp

BEGIN_MESSAGE_MAP(CParticleDialogApp, CWinApp)
	//{{AFX_MSG_MAP(CParticleDialogApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CParticleDialogApp construction

CParticleDialogApp::CParticleDialogApp()
: m_bShow(false)
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////

BOOL CParticleDialogApp::ShowDialog(bool bShow)
{
	m_bShow = bShow;
	m_Options.ShowWindow(bShow);
	return true;
}

BOOL CParticleDialogApp::Initialise(HWND hWnd)
{
	m_ParentWnd.Attach(hWnd);
	m_Options.Create(MAKEINTRESOURCE(IDD_OPTIONS), &m_ParentWnd);
	ZeroMemory(&m_Settings, sizeof(DialogSettings));


	return true;
}

BOOL CParticleDialogApp::Free()
{
	m_Options.DestroyWindow();
	m_ParentWnd.Detach();
	return true;
}
	
BOOL CParticleDialogApp::GetSettings(DialogSettings* pSettings) 
{
	assert(pSettings);

	DialogSettings Temp = m_Settings;
	
	m_Options.UpdateData(TRUE);

	m_Settings.total_particles = m_Options.m_TotalParticles;
	m_Settings.lifetime = m_Options.m_Lifetime;

	m_Settings.launch_speed = m_Options.m_LaunchSpeed;
	m_Settings.launch_accel = m_Options.m_LaunchAccel;

	m_Settings.start_scale = m_Options.m_StartScale;
	m_Settings.end_scale = m_Options.m_EndScale;

	m_Settings.start_rotation = m_Options.m_StartRotation;
	m_Settings.end_rotation = m_Options.m_EndRotation;

	m_Settings.wind_heading = m_Options.m_WindHeading;
	m_Settings.wind_pitch = m_Options.m_WindPitch;
	m_Settings.wind_scale = m_Options.m_WindScale;
	m_Settings.wind_start_effect = m_Options.m_WindEffectA;
	m_Settings.wind_end_effect = m_Options.m_WindEffectB;

	m_Settings.gravity_heading = m_Options.m_GravHeading;
	m_Settings.gravity_pitch = m_Options.m_GravPitch;
	m_Settings.gravity_scale = m_Options.m_GravScale;
	m_Settings.gravity_acceleration = m_Options.m_GravAccel;

	m_Settings.magnet_heading = m_Options.m_MagnetHeading;
	m_Settings.magnet_pitch = m_Options.m_MagnetPitch;
	m_Settings.magnet_distance = m_Options.m_MagnetDistance;
	m_Settings.magnet_strength = m_Options.m_MagnetStrength;
	m_Settings.magnet_start_effect = m_Options.m_MagnetEffectA;
	m_Settings.magnet_end_effect = m_Options.m_MagnetEffectB;

	m_Settings.start_red = m_Options.m_StartRed;
	m_Settings.start_green = m_Options.m_StartGreen;
	m_Settings.start_blue = m_Options.m_StartBlue;
	m_Settings.start_alpha = m_Options.m_StartAlpha;

	m_Settings.end_red = m_Options.m_EndRed;
	m_Settings.end_green = m_Options.m_EndGreen;
	m_Settings.end_blue = m_Options.m_EndBlue;
	m_Settings.end_alpha = m_Options.m_EndAlpha;

	lstrcpyn(m_Settings.texture_path, m_Options.m_TexturePath.GetBuffer(MAX_PATH), MAX_PATH);

	if (memcmp(&Temp, &m_Settings, sizeof(DialogSettings)) != 0)
	{
		m_Settings.dirty_flag = true;
	}
	else
	{
		m_Settings.dirty_flag = false;
	}

	if (memcmp(Temp.texture_path, m_Settings.texture_path, MAX_PATH) != 0)
	{
		m_Settings.new_path_name = true;
	}
	else
	{
		m_Settings.new_path_name = false;
	}

	*pSettings = m_Settings;

	return true;
}

BOOL CParticleDialogApp::SetSettings(DialogSettings* pSettings) 
{
	assert(pSettings); 
	m_Settings = *pSettings;
	
	m_Options.m_TotalParticles = pSettings->total_particles;
	m_Options.m_Lifetime = pSettings->lifetime;

	m_Options.m_LaunchSpeed = pSettings->launch_speed;
	m_Options.m_LaunchAccel = pSettings->launch_accel;

	m_Options.m_StartScale = pSettings->start_scale;
	m_Options.m_EndScale = pSettings->end_scale;

	m_Options.m_StartRotation = pSettings->start_rotation;
	m_Options.m_EndRotation = pSettings->end_rotation;

	m_Options.m_WindHeading = pSettings->wind_heading;
	m_Options.m_WindPitch = pSettings->wind_pitch;
	m_Options.m_WindScale = pSettings->wind_scale;
	m_Options.m_WindEffectA = pSettings->wind_start_effect;
	m_Options.m_WindEffectB = pSettings->wind_end_effect;

	m_Options.m_GravHeading = pSettings->gravity_heading;
	m_Options.m_GravPitch = pSettings->gravity_pitch;
	m_Options.m_GravScale = pSettings->gravity_scale;
	m_Options.m_GravAccel = pSettings->gravity_acceleration;

	m_Options.m_MagnetHeading = pSettings->magnet_heading;
	m_Options.m_MagnetPitch = pSettings->magnet_pitch;
	m_Options.m_MagnetDistance = pSettings->magnet_distance;
	m_Options.m_MagnetStrength = pSettings->magnet_strength;
	m_Options.m_MagnetEffectA = pSettings->magnet_start_effect;
	m_Options.m_MagnetEffectB = pSettings->magnet_end_effect;

	m_Options.m_StartRed = pSettings->start_red;
	m_Options.m_StartGreen = pSettings->start_green;
	m_Options.m_StartBlue = pSettings->start_blue;
	m_Options.m_StartAlpha = pSettings->start_alpha;

	m_Options.m_EndRed = pSettings->end_red ;
	m_Options.m_EndGreen = pSettings->end_green;
	m_Options.m_EndBlue = pSettings->end_blue;
	m_Options.m_EndAlpha = pSettings->end_alpha;

	m_Options.m_TexturePath = pSettings->texture_path;

	m_Options.m_TextureName = m_Options.m_TexturePath;

//	m_Options.UpdateData(FALSE);
	m_Options.UpdateControls();

	return true;
}

BOOL CParticleDialogApp::SetMaxParticles(int MaxParticles)
{
	m_Options.SetMaxParticles(MaxParticles);
	return(TRUE);
}

BOOL CParticleDialogApp::InitInstance() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CWinApp::InitInstance();
}

int CParticleDialogApp::ExitInstance() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CWinApp::ExitInstance();
}
