#if !defined(AFX_PARTICLEOPTIONS_H__22D78C86_AB50_4635_A775_1A0D3B76B17E__INCLUDED_)
#define AFX_PARTICLEOPTIONS_H__22D78C86_AB50_4635_A775_1A0D3B76B17E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ParticleOptions.h : header file
//

#define MIN_TIME 0.1f
#define MAX_TIME 50.0f

#define MIN_SCALE -5.0f
#define MAX_SCALE 5.0f

#define MIN_ANGLE 0.0f
#define MAX_ANGLE 6.28f

#define MIN_ROTATION 0.0f
#define MAX_ROTATION 500.0f

#define MIN_ACCEL 0.1f
#define MAX_ACCEL 5.0f

#define MIN_DISTANCE -50.0f
#define MAX_DISTANCE 50.0f

#define MIN_COLOR 0.0f
#define MAX_COLOR 2.0f

#define SLIDER_STEPS 1000

/////////////////////////////////////////////////////////////////////////////
// CParticleOptions dialog

class CParticleOptions : public CDialog
{
// Construction
public:
	CParticleOptions(CWnd* pParent = NULL);   // standard constructor

	int m_TotalParticles;
	float m_Lifetime;
	float m_GravScale;
	float m_GravPitch;
	float m_GravHeading;
	float m_GravAccel;
	float m_WindHeading;
	float m_WindPitch;
	float m_WindScale;
	float m_MagnetHeading;
	float m_MagnetPitch;
	float m_MagnetDistance;
	float m_MagnetStrength;
	float m_LaunchSpeed;
	float m_LaunchAccel;
	float m_StartScale;
	float m_EndScale;
	float m_StartRotation;
	float m_EndRotation;
	float m_WindEffectA;
	float m_WindEffectB;
	float m_MagnetEffectA;
	float m_MagnetEffectB;

	float m_StartRed;
	float m_StartGreen;
	float m_StartBlue;
	float m_StartAlpha;
	float m_EndRed;
	float m_EndGreen;
	float m_EndBlue;
	float m_EndAlpha;

	CString m_TexturePath;
	CString m_TextureName;

	float ConvertToFloat(float Min, float Max, int percent);
	int ConvertToPercent(float Min, float Max, float value);
	void SetTextValue(CStatic& control, float value);

	void UpdateControls();
	BOOL SetMaxParticles(int MaxParticles);

// Dialog Data
	//{{AFX_DATA(CParticleOptions)
	enum { IDD = IDD_OPTIONS };
	CStatic	m_TexturePathReadout;
	CSliderCtrl	m_StartRedSlider;
	CSliderCtrl	m_StartGreenSlider;
	CStatic	m_StartColorReadout;
	CSliderCtrl	m_StartBlueSlider;
	CSliderCtrl	m_StartAlphaSlider;
	CSliderCtrl	m_LaunchAccelSlider;
	CStatic	m_LaunchAccelReadout;
	CStatic	m_EndColorReadout;
	CSliderCtrl	m_EndRedSlider;
	CSliderCtrl	m_EndGreenSlider;
	CSliderCtrl	m_EndBlueSlider;
	CSliderCtrl	m_EndAlphaSlider;
	CSliderCtrl	m_LifetimeSlider;
	CStatic		m_LifetimeReadout;
	CSliderCtrl	m_GravScaleSlider;
	CStatic		m_GravScaleReadout;
	CSliderCtrl	m_GravPitchSlider;
	CStatic		m_GravPitchReadout;
	CSliderCtrl	m_GravHeadingSlider;
	CStatic		m_GravHeadingReadout;
	CSliderCtrl	m_GravAccelSlider;
	CStatic		m_GravAccelReadout;
	CSliderCtrl	m_WindHeadingSlider;
	CStatic		m_WindHeadingReadout;
	CSliderCtrl	m_WindPitchSlider;
	CStatic		m_WindPitchReadout;
	CSliderCtrl	m_WindScaleSlider;
	CStatic		m_WindScaleReadout;
	CSliderCtrl	m_TotalParticlesSlider;
	CStatic		m_TotalParticlesReadout;
	CSliderCtrl	m_MagnetHeadingSlider;
	CStatic		m_MagnetHeadingReadout;
	CSliderCtrl	m_MagnetPitchSlider;
	CStatic		m_MagnetPitchReadout;
	CSliderCtrl	m_MagnetDistanceSlider;
	CStatic		m_MagnetDistanceReadout;
	CSliderCtrl	m_MagnetStrengthSlider;
	CStatic		m_MagnetStrengthReadout;
	CSliderCtrl	m_LaunchSpeedSlider;
	CStatic		m_LaunchSpeedReadout;
	CSliderCtrl	m_StartScaleSlider;
	CStatic		m_StartScaleReadout;
	CSliderCtrl	m_EndScaleSlider;
	CStatic		m_EndScaleReadout;
	CSliderCtrl	m_StartRotationSlider;
	CStatic		m_StartRotationReadout;
	CSliderCtrl	m_EndRotationSlider;
	CStatic		m_EndRotationReadout;
	CSliderCtrl	m_WindEffectASlider;
	CStatic		m_WindEffectAReadout;
	CSliderCtrl	m_WindEffectBSlider;
	CStatic		m_WindEffectBReadout;
	CSliderCtrl	m_MagnetEffectASlider;
	CStatic		m_MagnetEffectAReadout;
	CSliderCtrl	m_MagnetEffectBSlider;
	CStatic		m_MagnetEffectBReadout;	
	//}}AFX_DATA



// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CParticleOptions)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CParticleOptions)
	virtual BOOL OnInitDialog();
	afx_msg void OnCustomdrawEndRotationSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawEndScaleSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawGravAccelSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawGravHeadingSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawGravPitchSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawGravScaleSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawLaunchspeedSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawLifetimeSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawMagnetDistanceSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawMagnetEffectASlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawMagnetEffectBSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawMagnetHeadingSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawMagnetPitchSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawMagnetStrengthSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawStartRotationSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawStartScaleSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawTotalparticlesSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawWindEffectASlider2(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawWindEffectBSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawWindHeadingSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawWindPitchSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawWindScaleSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawStartAlphaSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawStartBlueSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawStartGreenSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawStartRedSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawEndAlphaSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawEndBlueSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawEndGreenSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawEndRedSlider5(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCustomdrawLaunchAccelSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnLoadTexture();
	afx_msg void OnSave();
	afx_msg void OnLoad();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PARTICLEOPTIONS_H__22D78C86_AB50_4635_A775_1A0D3B76B17E__INCLUDED_)
