#ifndef __COMMON_H
#define __COMMON_H

typedef struct _DialogSettings
{
	bool  dirty_flag;

	int total_particles;
	float lifetime;

	float launch_speed;
	float launch_accel;

	float start_scale;
	float end_scale;

	float start_rotation;
	float end_rotation;

	float wind_heading;
	float wind_pitch;
	float wind_scale;
	float wind_start_effect;
	float wind_end_effect;

	float gravity_heading;
	float gravity_pitch;
	float gravity_scale;
	float gravity_acceleration;

	float magnet_heading;
	float magnet_pitch;
	float magnet_distance;
	float magnet_strength;
	float magnet_start_effect;
	float magnet_end_effect;

	float start_red;
	float start_green;
	float start_blue;
	float start_alpha;

	float end_red;
	float end_green;
	float end_blue;
	float end_alpha;

	bool new_path_name;
	char texture_path[MAX_PATH];

} DialogSettings;


extern "C" 
{

#ifdef OPTIONSDIALOG
_declspec(dllexport) BOOL ParticleDialog_ShowDialog(bool bShow);
_declspec(dllexport) BOOL ParticleDialog_Initialise(HWND hWndParent);
_declspec(dllexport) BOOL ParticleDialog_Free();
_declspec(dllexport) BOOL ParticleDialog_GetSettings(DialogSettings* pSettings);
_declspec(dllexport) BOOL ParticleDialog_SetSettings(DialogSettings* pSettings);
_declspec(dllexport) BOOL ParticleDialog_SetMaxParticles(int MaxParticles);

#else

typedef BOOL (*LPSHOWDIALOG)(bool);
typedef BOOL (*LPINITIALISE)(HWND);
typedef BOOL (*LPFREE)();
typedef BOOL (*LPGETSETTINGS)(DialogSettings*);
typedef BOOL (*LPSETSETTINGS)(DialogSettings*);
typedef BOOL (*LPSETMAXPARTICLES)(int);
typedef struct tagOptionsDialogFunc
{
	LPSHOWDIALOG ShowDialog;
	LPINITIALISE Initialise;
	LPFREE Free;
	LPGETSETTINGS GetSettings;
	LPSETSETTINGS SetSettings;
	LPSETMAXPARTICLES SetMaxParticles;
} OptionsDialogFunc;

#endif // OPTIONSDIALOG

} // extern "C"

#endif // __COMMON_H