/******************************************************************************

  shader_constants.h
      
        
******************************************************************************/

// the screen projection
// lifespan, current time, 1.0f/lifespan, lives_elapsed
#define CV_TIME			0	
// origin of particle system in view space
#define CV_ORIGIN		1	
// gravity vector of particle system in view space
#define CV_GRAVITY		2	
// current wind vector in view space
#define CV_WIND			3	
// location of particle system attractor in view space
#define CV_MAGNET		4	

// r,g,b,a of starting vertex colors
#define CV_COLOR_A		5	
// r,g,b,a of ending vertex colors
#define CV_COLOR_B		6	
// starting and ending scale and rotation for the particle
#define CV_SCALE_AND_SPIN	7	
// starting and ending pull of the magnet location
#define CV_MAGNET_EFFECT	8	
// starting and ending pull of the wind direction
#define CV_WIND_EFFECT		9	

// x,y offset and U,V coordinates of vertex 0
#define CV_VERTEX_0		13	
// x,y offset and U,V coordinates of vertex 1
#define CV_VERTEX_1		14	
// x,y offset and U,V coordinates of vertex 2
#define CV_VERTEX_2		15	


// particle weights (trajectory, gravity, wind, magnet) 
#define CV_TRAJECTORY_ACCEL		16	
#define CV_GRAVITY_ACCEL		17	

#define CV_TRAJECTORY_SPEED		19	
#define CV_MAGNET_STRENGTH		20	

#define CV_WORLDVIEW_0 23
#define CV_WORLDVIEW_1 24
#define CV_WORLDVIEW_2 25
#define CV_WORLDVIEW_3 26

#define CV_PROJ_0 30
#define CV_PROJ_1 31
#define CV_PROJ_2 32
#define CV_PROJ_3 33

// sizeof vector table (16), sizeof sincos table (32), ?? ,?? 
#define CV_CONSTANTS	37

// most powerful light data
#define CV_LIGHT1_POSITION		38
#define CV_LIGHT1_DIFFUSE		39
#define CV_LIGHT1_ATTENUATION	40
#define CV_LIGHT1_RANGE			41

// average of all additional lights
#define CV_LIGHT2_POSITION		42
#define CV_LIGHT2_DIFFUSE		43
#define CV_LIGHT2_ATTENUATION	44
#define CV_LIGHT2_RANGE			45

#define CV_SINCOS_TABLE_0			48
#define CV_SINCOS_TABLE_1			49
#define CV_SINCOS_TABLE_2			50
#define CV_SINCOS_TABLE_3			51
#define CV_SINCOS_TABLE_4			52
#define CV_SINCOS_TABLE_5			53
#define CV_SINCOS_TABLE_6			54
#define CV_SINCOS_TABLE_7			55
#define CV_SINCOS_TABLE_8			56
#define CV_SINCOS_TABLE_9			57
#define CV_SINCOS_TABLE_10			58
#define CV_SINCOS_TABLE_11			59
#define CV_SINCOS_TABLE_12			60
#define CV_SINCOS_TABLE_13			61
#define CV_SINCOS_TABLE_14			62
#define CV_SINCOS_TABLE_15			63
#define CV_SINCOS_TABLE_16			64
#define CV_SINCOS_TABLE_17			65
#define CV_SINCOS_TABLE_18			66
#define CV_SINCOS_TABLE_19			67
#define CV_SINCOS_TABLE_20			68
#define CV_SINCOS_TABLE_21			69
#define CV_SINCOS_TABLE_22			70
#define CV_SINCOS_TABLE_23			71
#define CV_SINCOS_TABLE_24			72
#define CV_SINCOS_TABLE_25			73
#define CV_SINCOS_TABLE_26			74
#define CV_SINCOS_TABLE_27			75
#define CV_SINCOS_TABLE_28			76
#define CV_SINCOS_TABLE_29			77
#define CV_SINCOS_TABLE_30			78
#define CV_SINCOS_TABLE_31			79

#define CV_UV_TABLE_V0_FRAME0		80
#define CV_UV_TABLE_V0_FRAME1		81
#define CV_UV_TABLE_V0_FRAME2		82
#define CV_UV_TABLE_V0_FRAME3		83
#define CV_UV_TABLE_V1_FRAME0		84
#define CV_UV_TABLE_V1_FRAME1		85
#define CV_UV_TABLE_V1_FRAME2		86
#define CV_UV_TABLE_V1_FRAME3		87
#define CV_UV_TABLE_V2_FRAME0		88
#define CV_UV_TABLE_V2_FRAME1		89
#define CV_UV_TABLE_V2_FRAME2		90
#define CV_UV_TABLE_V2_FRAME3		91

// Vertex components
// (x_direction, y_direction, z_direction, [vertex number + birthtime])
// the last parameter is the whole number of the vertex (0,1, or 2) plus the fraction part of the birth offset (0-0.999)
#define V_PARTICLE	v0 

// origin is used by particle shader #2 as the birth position
#define V_ORIGIN	v1 




