/******************************************************************************

  Copyright (C) 1999, 2000 NVIDIA Corporation
  This file is provided without support, instruction, or implied warranty of any
  kind.  NVIDIA makes no guarantee of its fitness for a particular purpose and is
  not liable under any circumstances for any damages or loss whatsoever arising
  from the use or inability to use this file or items derived from it.
  
    Comments:
    
      
        
******************************************************************************/

#ifndef __SHADER_SPYRORAMA_H
#define __SHADER_SPYRORAMA_H
#include "MouseUI.h"

typedef struct tagSpyroVertex
{
	D3DXVECTOR3 pos;
	D3DXVECTOR3 normal;
	D3DXVECTOR2 texture;
} SpyroVertex;

#define SPYRO_D3DVERTEX (D3DFVF_XYZ|D3DFVF_NORMAL|D3DFVF_TEX1)

class CShaderSpyrorama : public EBEffect
{
public:
	CShaderSpyrorama();
	~CShaderSpyrorama();
	virtual void UpdateProperties();
	virtual HRESULT Initialize(LPDIRECT3DDEVICE8 pDev);
	virtual HRESULT Free();
	virtual HRESULT Start();
	virtual HRESULT Tick(EBTimer* pTimer);
	virtual HRESULT ConfirmDevice(D3DCAPS8* pCaps, DWORD dwBehavior, D3DFORMAT Format);
	virtual void Keyboard(DWORD dwKey, UINT nFlags, bool bDown);
	virtual void MouseButton(HWND hWnd, eButtonID button, bool bDown, int x, int y);
	virtual void MouseMove(HWND hWnd, int x, int y);
	
private:
	void ShiftPattern();

	DWORD m_dwCurrentShader;
	LPDIRECT3DVERTEXBUFFER8 m_pObjVB;
	LPDIRECT3DINDEXBUFFER8 m_pObjIB;
	int m_NumObjVertices;
	int m_NumObjFaces;
	D3DXVECTOR4 m_vRotateDir, m_vPleats, m_vPhaseShift;
	FLOAT m_fLastShift;
	
	bool m_bWireframe;
	MouseUI* m_pUI;

};

#endif