/*********************************************************************NVMH2****
Path:  E:\devrel\NV_SDK_4\DX8\NVEffectsBrowser\Effects\Aniso
File:  shader_Aniso.h

Copyright (C) 1999, 2000 NVIDIA Corporation
This file is provided without support, instruction, or implied warranty of any
kind.  NVIDIA makes no guarantee of its fitness for a particular purpose and is
not liable under any circumstances for any damages or loss whatsoever arising
from the use or inability to use this file or items derived from it.

Comments:


******************************************************************************/


#ifndef SHADER_Aniso_H
#define SHADER_Aniso_H
#include "MouseUI.h"
#include <string>

#define NUM_MODELS	2

struct FuzzVertex
{
	float x, y, z;
	float nx, ny, nz;
	float u,v;         //texcoord for stage 0
	enum FVF
	{
		FVF_Flags = D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1
	};
};

class CShaderFuzz : public EBEffect
{
public:	
	CShaderFuzz(int CurrentModel);
	~CShaderFuzz();

	virtual void PropertyUpdateCallback(const EBProperty* pProperty, bool bWritten );

	virtual void    UpdateProperties();
	virtual HRESULT Initialize(IDirect3DDevice8* pDev);
	virtual HRESULT Free();
	virtual HRESULT Start();
	virtual HRESULT Tick(EBTimer* pTimer);
	virtual HRESULT ConfirmDevice(D3DCAPS8* pCaps, DWORD dwBehavior, D3DFORMAT Format);
	virtual void MouseMove(HWND hWnd, int x, int y);
	virtual void MouseButton(HWND hWnd, eButtonID Button, bool bDown, int x, int y);
	virtual void Keyboard(DWORD dwKey, UINT nFlags, bool bDown);
	
private:

	LPDIRECT3DVERTEXBUFFER8 m_pVertexBuffer[NUM_MODELS];
	LPDIRECT3DINDEXBUFFER8  m_pIndexBuffer[NUM_MODELS];

	LPDIRECT3DTEXTURE8 m_pShadeTexture[NUM_MODELS];
	
	D3DXATTRIBUTERANGE *m_pAttributes[NUM_MODELS];
	
	//our matrices
	D3DXMATRIX m_world;
	D3DXMATRIX m_view;
	D3DXMATRIX m_proj;
	
	//number of sections in the mesh
	DWORD m_dwNumSections[NUM_MODELS];
	
	DWORD m_dwCurrentShader;

	std::string m_strFileName[NUM_MODELS];
	std::string m_strTextureName[NUM_MODELS];

	bool m_bWireframe;
	bool m_bUseTrilinear;
	MouseUI* m_pUI;

	D3DXVECTOR3 m_lookAt;
	D3DXVECTOR3 m_up;
	D3DXVECTOR4 m_eye;

	HRESULT LoadXFile(int idx,const char* fileName, const DWORD dwFVF);
	HRESULT SetVertexShaderMatrices();
	HRESULT SetTextureStageStates(bool Fuzz);

	int m_nLayers;
	int m_nCurModel;
	float m_fOffset[NUM_MODELS];
	
};

#endif