// handy constants for the shader xyzw: 0, 1, 2, 3
#define _Constants 4
// diffuse color
#define _Diffuse 5
// specular color
#define _Specular 6
// shading parameters
// x: model to screen space scaling
// y: ks specular reflection coefficient
// z: kn specular sharpness 
// w: transparency fade along the hair
#define _ShaderParameters 8
// constant bending vector
#define _Bend 9
// bending parameters
// x: dynamic bending scale factor
// y: max bend
#define _BendParameters 10
// xyz: gravity point, w: influence factor
#define _Gravity 11
// bending function coefficients
#define _Spline 12
// transformation from model to clip space Model*View*Proj
#define _ProjectionMatrix 15
// transformation from model to camera space Model*View
#define _WorldMatrix 19
// vector pointing towards the light
#define _LightVector 23
// dynamic bending
#define _DynamicBendMatrix 24
