/******************************************************************************

  Copyright (C) 1999, 2000 NVIDIA Corporation
  This file is provided without support, instruction, or implied warranty of any
  kind.  NVIDIA makes no guarantee of its fitness for a particular purpose and is
  not liable under any circumstances for any damages or loss whatsoever arising
  from the use or inability to use this file or items derived from it.
  
    Comments:
    
      
        
******************************************************************************/
#pragma once 

#include "MouseUI.h"
#include "Hair.h"
#include "nvmesh.h"
#include "nvdevice.h"

typedef struct tagQuadVertex
{
	D3DXVECTOR3 Position;
	D3DXVECTOR3 Normal;
	D3DXVECTOR2 Texture;
} QuadVertex;

class CShaderHair : public EBEffect
{
public:
	CShaderHair(SurfaceType surfaceType);
	~CShaderHair();
	virtual void UpdateProperties();
	virtual HRESULT Initialize(LPDIRECT3DDEVICE8 pDev);
	virtual HRESULT Free();
	virtual HRESULT Start();
	virtual HRESULT Tick(EBTimer* pTimer);
	virtual HRESULT ConfirmDevice(D3DCAPS8* pCaps, DWORD dwBehavior, D3DFORMAT Format);
	virtual void Keyboard(DWORD dwKey, UINT nFlags, bool bDown);
	virtual void MouseButton(HWND hWnd, eButtonID button, bool bDown, int x, int y);
	virtual void MouseMove(HWND hWnd, int x, int y);
	
private:
	nv_objects::NVDevice *m_pNVDevice;
	nv_objects::NVMesh *m_pSphere, *m_pTorus;

	DWORD m_iTris, m_iVerts;

	LPDIRECT3DTEXTURE8 m_pLogoTexture;
	bool m_bWireframe, m_bUseBend, m_bShowTorus;
	MouseUI* m_pUI;
	D3DXVECTOR3 lightDirection;

	SurfaceType surfaceType;
	std::auto_ptr<HairPatch> pHairPatch;

	createHair(int nHairs, int nSegments, float length, float radius);

};

