//-----------------------------------------------------------------------------
// author: Laurent MASCHERPA
// email:  laurent.mascherpa@epita.fr
// date:   03/05/2001
//-----------------------------------------------------------------------------

#ifndef __SHADER_PLASMA_HPP__
#define __SHADER_PLASMA_HPP__

#include "MouseUI.h"

typedef struct tagQuadVertex
{
	D3DXVECTOR3 Position;
	D3DXVECTOR3 Normal;
	D3DXVECTOR2 Texture;
} QuadVertex;

#define	DEFAULT_GRID_SIZE	64

/**
* CShaderPlasma:
* the plasma effect.
*/
class CShaderPlasma : public EBEffect
{
public:
	CShaderPlasma();
	~CShaderPlasma();
	virtual void UpdateProperties();
	virtual HRESULT Initialize(LPDIRECT3DDEVICE8 pDev);
	virtual HRESULT Free();
	virtual HRESULT Start();
	virtual HRESULT Tick(EBTimer* pTimer);
	virtual HRESULT ConfirmDevice(D3DCAPS8* pCaps, DWORD dwBehavior, D3DFORMAT Format);
	virtual void Keyboard(DWORD dwKey, UINT nFlags, bool bDown);
	virtual void MouseButton(HWND hWnd, eButtonID button, bool bDown, int x, int y);
	virtual void MouseMove(HWND hWnd, int x, int y);
	
private:
	DWORD m_dwCurrentShader;
	LPDIRECT3DVERTEXBUFFER8 m_pVertexBuffer;
	LPDIRECT3DTEXTURE8 m_pLogoTexture;
	bool m_bWireframe;
	MouseUI* m_pUI;
	int	m_dwGridSize;
	int	m_dwNumVertices;
};

#endif	//__SHADER_PLASMA_HPP__