/*************************************************************************
File:  shader_Spline.h

Lee Baldwin
Copyright (C) 2001
Comments:

******************************************************************************/


#ifndef SHADER_Spline_H
#define SHADER_Spline_H

#include "MouseUI.h"

typedef struct SplineVertex
{
	float dt;
} SplineVertex;


class CShaderSpline : public EBEffect
{
public:
	CShaderSpline();
	~CShaderSpline();
	virtual void UpdateProperties();
	virtual HRESULT Initialize(LPDIRECT3DDEVICE8 pDev);
	virtual HRESULT Free();
	virtual HRESULT Start();
	virtual HRESULT Tick(EBTimer* pTimer);
	virtual HRESULT ConfirmDevice(D3DCAPS8* pCaps, DWORD dwBehavior, D3DFORMAT Format);
	virtual void Keyboard(DWORD dwKey, UINT nFlags, bool bDown);
	virtual void MouseButton(HWND hWnd, eButtonID button, bool bDown, int x, int y);
	virtual void MouseMove(HWND hWnd, int x, int y);
	virtual void PropertyUpdateCallback(const EBProperty* pProperty, bool bWritten );

private:
	DWORD m_dwCurrentShader;
	LPDIRECT3DVERTEXBUFFER8 m_pVertexBuffer;
	bool m_bAnimateEndPts;
	MouseUI* m_pUI;
	int	 n_Segments;
	float y_axis;
	float dy_axis;

	D3DXVECTOR3 v1, v1out, v2in, v2;

	void SetConstantRegisters( void );
	HRESULT SetupSegmentVerts( void );

};

#endif