// twister.h


#ifndef __TWISTER_H
#define __TWISTER_H

struct pair
{
	int number;
	int coefficient;

};


class CTwister : public EBEffect
{

public:
	CTwister(int index);

	~CTwister();

	virtual void PropertyUpdateCallback(const EBProperty* pProperty, bool bWritten );

	virtual void UpdateProperties();

	HRESULT LoadXFile(const char* fileName, const DWORD dwFVF);
	HRESULT SetVertexShaderMatrices();

	void    SetVSConst();

	virtual HRESULT ConfirmDevice(D3DCAPS8* pCaps, DWORD dwBehavior, D3DFORMAT Format);
	virtual HRESULT Initialize(LPDIRECT3DDEVICE8 pDev);
	virtual HRESULT Free();
	virtual HRESULT Start();
	virtual HRESULT Tick(EBTimer* pTimer);
	virtual void MouseMove(HWND hWnd, int x, int y);
	virtual void MouseButton(HWND hWnd, eButtonID Button, bool bDown, int x, int y);
	virtual void Keyboard(DWORD dwKey, UINT nFlags, bool bDown);

private:
	DWORD m_dwCurrentShader;
	std::string m_strFileName;
	DWORD m_dwNumSections;

	LPDIRECT3DVERTEXBUFFER8		m_pVertexBuffer;
	LPDIRECT3DINDEXBUFFER8    m_pIndexBuffer;
	MouseUI* m_pUI;

	//bounding sphere attributes
	float m_fRadius;
	D3DXVECTOR3 m_vecCenter;

    D3DMATERIAL8*       m_pMaterials;
    LPDIRECT3DTEXTURE8* m_pTextures;


	D3DXATTRIBUTERANGE*  m_pAttributes;
	bool                 m_bWireframe;
	bool                 m_bPause;
	FLOAT                m_fLoop;
	FLOAT                m_fTick;
	FLOAT                m_fStep ;
	FLOAT               *m_pfTabSine;
	FLOAT               *m_pfTabCosine;
	int                  m_iSpeed;
	FLOAT                m_fOffset;
	BOOL                 m_bAxeY;

	int                  m_iNum;
	
	D3DXMATRIX m_world;
	D3DXMATRIX m_view;
	D3DXMATRIX m_proj;


	
};

#endif
